package com.nisum.omd;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.nisum.omd.domain.Order;
import com.nisum.omd.service.RandomDataGeneratorImpl;

@Component
public class OrderGenerator implements CommandLineRunner{

	@Autowired
	RandomDataGeneratorImpl rdg;
	@Autowired
	Order order;
	Boolean orderGenerateFlag =  true;
	
	public Boolean getOrderGenerateFlag() {
		return orderGenerateFlag;
	}

	public void setOrderGenerateFlag(Boolean orderGenerateFlag) {
		this.orderGenerateFlag = orderGenerateFlag;
	}

	public void run(String... args) throws Exception {

		  while(orderGenerateFlag){
		  order=getObjectData(order);
		  ObjectMapper objectMapper = new ObjectMapper();
		  String jsonOrderStr = objectMapper.writeValueAsString(order);		
		  System.out.println(jsonOrderStr);
		  }
	}

	public Order getObjectData(Order order2) {
		
    	order.setOrderNum(rdg.generateOrderNumber());
		order.setCustomerId(rdg.generateCustomerId());
		order.setLineItem(rdg.genetateLineItem(order.getLineItem()));
        return order;
	}


}
